#!/afs/msc.cornell.edu/i386_linux22/usr/local/pub/dm/bin/python

import sys
import string

class GeometryParser:

    def __init__(self,filename):

        self.GeometryParameters={}
        self.GeoFile = open(filename,"r")
        self.numGeometries = int(self.GeoFile.readline())

    def ParseLine(self):
        
        line = self.GeoFile.readline()
        fields = string.splitfields(line)

        # fields are
        # 0      1      2 3           4       5 6           7       8              9    10
        # theta1 theta2 millerind1(2) repeat1 millerind2(2) repeat2 rationalApprox Size Strain

        self.GeometryParameters["angle1"]=float(fields[0])
        self.GeometryParameters["angle2"]=float(fields[1])
        self.GeometryParameters["length"]=float(fields[9])
        self.GeometryParameters["yystrain"]=float(fields[10])
        self.GeometryParameters["repeat1"]=float(fields[4])
        self.GeometryParameters["repeat2"]=float(fields[7])

        rationalApproxFields = string.splitfields(fields[8],"/")
        if len(rationalApproxFields) == 1:
            p = 1
            q = int(rationalApproxFields[0])
        else:
            p = int(rationalApproxFields[0])
            q = int(rationalApproxFields[1])

        length = self.GeometryParameters["length"]
        repeat1 = self.GeometryParameters["repeat1"]
        yyStrain = self.GeometryParameters["yystrain"]
        if abs(abs(p*repeat1-length)-yyStrain*length) < 1e-3:
            self.GeometryParameters["numRepeats1"] = p
            self.GeometryParameters["numRepeats2"] = q
        else:
            self.GeometryParameters["numRepeats1"] = q
            self.GeometryParameters["numRepeats2"] = p


if __name__ == "__main__":

    geoParser = GeometryParser("2DGeometries/TestGeo.dat")
    print geoParser.numGeometries

    for i in xrange(geoParser.numGeometries):
        geoParser.ParseLine()
        print geoParser.GeometryParameters
