#!/afs/msc.cornell.edu/i386_linux22/usr/local/pub/dm/bin/python

import sys
import os

class ASCIIObserver:

    def __init__(self, Parameters, ioControl):
        self.ioControl = ioControl

        self.ioControl.OpenFile("Parameters.txt")

        for key in Parameters.keys():
            self.ioControl.WriteToFile("Parameters.txt",key + " = " + repr(Parameters[key]) + "\n")
        self.ioControl.CloseFile("Parameters.txt")

    def Update(self, mdobj):
        self.ioControl.Print(3,"Writing frame " + repr(mdobj.frameNumber) + " to ASCII file")
        nAtoms = mdobj.atoms.GetNumber()
        positions = mdobj.atoms.GetCartesianPositions()[:]
        self.ioControl.OpenFile("atomdata" + repr(mdobj.frameNumber) + ".dat")
        if nAtoms > 0:
            for atIdx in xrange(nAtoms):
                line = ""
                for coord in xrange(len(positions[atIdx])):
                    line = line + repr(positions[atIdx][coord]) + "   "

                line = line + "\n"
                self.ioControl.WriteToFile("atomdata" + repr(mdobj.frameNumber) + ".dat",line)
        self.ioControl.CloseFile("atomdata" + repr(mdobj.frameNumber) + ".dat")

            
