#!/afs/msc.cornell.edu/i386_linux22/usr/local/pub/dm/bin/python

import sys
import Sybase

class DatabaseObserver:

    def __init__(self, guid, Parameters):
        self.databaseServer = Parameters["databaseServer"]
        self.database = Parameters["database"]
        self.username = "cmi"
        self.password = "cmi4now"

        db = Sybase.connect(self.databaseServer, self.username, self.password, self.database)
        #need to change table!
        thekeys = ["edgeToDecorate", "centerPositionParameter", "nSteps", "material", "radius", "length", "MDMoverType", "lengthScale", "displacementScale", "timestep"]
        parameterString = ""
        for key in thekeys:
            value = str(Parameters[key])
            if key in ["MDMoverType", "material"]:
                value = "\'" + value + "\'"            
            parameterString = parameterString + ", " + value
        queryString = "INSERT INTO OFEMD_Parameters VALUES(\'"+guid+"\'"+parameterString+")"
        db.execute(queryString)


    def Update(self, framenumber, ofemd=None):
        ofemd.ioControl.Print(3,"Writing frame " + str(framenumber) + " to database")
        nAtoms = ofemd.allAtoms.GetNumber()
        nFreeAtoms = ofemd.allAtoms.GetLeaf(0).GetNumber()
        positions = ofemd.allAtoms.GetCartesianPositions()[:]
        db = Sybase.connect(self.databaseServer, self.username, self.password, self.database)
        for atIdx in xrange(nAtoms):
            xPos,yPos,zPos = positions[atIdx]
            if atIdx < nFreeAtoms:
                constrained = 0
            else:
                constrained = 1
            energy = ofemd.potential.CalculateAtomicEnergy(ofemd.allAtoms,atIdx)

            queryString = """INSERT INTO OFEMD_AtomicInfo
            VALUES('"""+ofemd.guid+"', "+str(framenumber)+", "+str(atIdx)+", "+str(xPos)+", "+str(yPos)+", "+str(zPos)+""",
            """+str(constrained)+", "+str(energy)+")"
            db.execute(queryString)

        db.close
