#!/afs/msc.cornell.edu/i386_linux22/usr/local/pub/dm/bin/python

import sys
import os
from ASCIIObserver import *

class OFEMDASCIIObserver(ASCIIObserver):

    def __init__(self, Parameters, ioControl):
        ASCIIObserver.__init__(self, Parameters, ioControl)
        

    def Update(self, ofemd):
        ASCIIObserver.Update(self, ofemd)
        
        self.SaveMesh(ofemd)


    def SaveMesh(self, ofemd):
        if ofemd.frameNumber <= 1:
            self.ioControl.Print(3,"Writing Undeformed Tets")
            self.ioControl.OpenFile("undeformedtets.dat")
        else:
            self.ioControl.Print(3,"Writing Deformed Tets")
            self.ioControl.OpenFile("deformedtets.dat")

        #print undeformed or deformed node positions
        for tetID in ofemd.model.GetElemIds(): # for each tet
            node_nums = ofemd.model.GetElemData(tetID)[2]
            for i in xrange(4): # for each of the first four nodes (corner nodes)
                nodeCoords = ofemd.model.GetElemCoords(tetID)[i]
                if ofemd.frameNumber > 1:
                    for coord in xrange(3):
                        nodeCoords[coord] += ofemd.atomsDeformer.node_disps[node_nums[i]][coord]
                nodeString = str(nodeCoords[0]) + " " + str(nodeCoords[1]) + " " + str(nodeCoords[2]) + "\n"
                if ofemd.frameNumber <= 1:
                    self.ioControl.WriteToFile("undeformedtets.dat",nodeString)
                else:
                    self.ioControl.WriteToFile("deformedtets.dat",nodeString)
